#pragma once
#include "GXBase.h"
using namespace gxbase;
#include "SDL.h"

class Camera {
private:
	Point3 eye;
	Vector3 u,v,n;
	double viewAngle, aspect, nearDist, farDist; // view volume shape
	float H, W;
	static const float M_PI;
	void setModelviewMatrix(); // tell OpenGL where the camera is
public:
	Camera(); // default constructor
	~Camera(void);
	void set(Point3 eye, Point3 look, Vector3 up); // like gluLookAt()
	void raytrace(Scene& scn, int blockSize);
	void roll(float angle); // roll it
	void pitch(float angle); // increase pitch
	void yaw(float angle); // yaw it
	void slide(float delU, float delV, float delN); // slide it
	void setShape(float vAng, float asp, float nearD, float farD);
	void setModelViewMatrix();
};
